//modified:2002.03.02@18:19 by Alex
//modified:2001.09.24 yyyy.mm.dd 02:00 by Burkart
//done: RCPT kann auch 0 sein
//done: Hex/Asc kopieren vertauscht
//done: Sender kann eigentlich nicht 0 sein, oder?
//done: Multipacket kann auch > 127 sein (0..255)
//done: Content ID kann auch 0 sein (Login data Client->Server)
//TODO: Hexdarstellung bei jeder nderung aktualisieren, nicht manuell -> wird bei groen Dateien langsam
//TODO: Hexdarstellung: Angeklickte Zahl hervorheben & Cursor lschen  -> berflssig oder?
//done: StatusBar: Werte zustzlich auch hexadezimal anzeigen          -> ok, aber warum eigentlich?
//TODO: evtl. Daten beim Beenden speichern                             -> ach n
//2001.12.03:
//* implemented connection to SerCom on port 666
//2001.12.16:
//* implemented direct enter in hex code and check of packet
//2001.12.21:
//* now interlink compatible
//2002.01.02:
//* receive and analyse packets
//2002.03.02:
//* you can use <123> and #123 in MemoData
//* saving (and loading) preferences

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ClipBrd, Menus, Math, UnitMy,
  UnitIDs, UnitData, WSocket, WSocketS;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    EditRcpt: TEdit;
    EditLen: TEdit;
    EditID: TEdit;
    EditSender: TEdit;
    EditMP: TEdit;
    MemoData: TMemo;
    Label7: TLabel;
    EditChecksum: TEdit;
    MemoOut: TMemo;
    CmdHex: TButton;
    Label8: TLabel;
    Label9: TLabel;
    StatusBar: TStatusBar;
    CmdCopyHex: TButton;
    CmdCopyAsc: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ComboCheck: TComboBox;
    Label10: TLabel;
    CheckAutoUpdate: TCheckBox;
    Client: TWSocket;
    CmdCheck: TButton;
    Server: TWSocketServer;
    ImageConnect: TImage;
    CmdSend: TButton;
    procedure ReCalc(updatehex:boolean);
    procedure EditRcptChange(Sender: TObject);
    procedure EditIDChange(Sender: TObject);
    procedure EditSenderChange(Sender: TObject);
    procedure EditMPChange(Sender: TObject);
    procedure MemoDataChange(Sender: TObject);
    procedure MemoDataKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure CmdHexClick(Sender: TObject);
    procedure CmdCopyHexClick(Sender: TObject);
    procedure CmdCopyAscClick(Sender: TObject);
    procedure DoCRC8(var crc8:byte;x:byte);
    procedure ComboCheckChange(Sender: TObject);
    procedure EditIDDblClick(Sender: TObject);
    procedure MemoDataDblClick(Sender: TObject);
    procedure CheckAutoUpdateClick(Sender: TObject);
    procedure CmdSendClick(Sender: TObject);
    procedure CheckPacket(data:string);
    procedure CmdCheckClick(Sender: TObject);
    procedure MemoOutKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MemoOutKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MemoOutKeyPress(Sender: TObject; var Key: Char);
    procedure Refresh;
    function  DeCodeText(text:String):string;
    function  EncodeText(text:string):string;
    procedure MemoOutClick(Sender: TObject);
    procedure ILGet(text:string);
    procedure ILSend(data:string);
    procedure FormShow(Sender: TObject);
    procedure ServerClientConnect(Sender: TObject; Client: TWSocketClient; Error: Word);
    procedure ServerDataAvailable(Sender: TObject; Error: Word);
    procedure ClientDataAvailable(Sender: TObject; Error: Word);
    procedure ClientSessionConnected(Sender: TObject; Error: Word);
    procedure ServerClientDisconnect(Sender: TObject;
      Client: TWSocketClient; Error: Word);
    procedure ClientSessionClosed(Sender: TObject; Error: Word);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1    : TForm1;
  packet   : string; //global, da auch in MemoOut.OnKeyPress ntig
  up2date  : boolean;//gibt an, ob die Hexdarstellung seit letzter nderung der Daten aktualisiert wurde
  started  : boolean;
  use      : array of TWSocket;
  ilbuffer : string;
  DataText : string; //enthlt MemoData.Text decodiert (nicht umschrieben)

implementation

{$R *.DFM}

procedure TForm1.ReCalc(updatehex:boolean);
//berechnet alles neu
var
  rcpt,id,sender,mpinf : integer;
  len,i                : integer;
  check                : byte;
begin
  //eigegebene Werte auf Gltigkeit berprfen
  Val(EditRcpt.Text,rcpt,i);
  if rcpt<0 then rcpt:=0
  else if rcpt>255 then rcpt:=255;
  EditRcpt.text:=inttostr(rcpt);
  Val(EditID.Text,ID,i);
  if (ID<0) or (ID>255) then begin
    ID:=1;
  end;
  EditID.text:=inttostr(ID);
  Val(EditSender.Text,sender,i);
  if sender<1 then sender:=1
  else if sender>255 then sender:=255;
  EditSender.Text:=inttostr(sender);
  Val(EditMP.Text,mpinf,i);
  if mpinf<1 then mpinf:=1
  else if mpinf>255 then mpinf:=255;
  EditMP.text:=inttostr(mpinf);
  //Lnge
  len:=6+length(DataText);
  EditLen.Text:=inttostr(len);
  //Paket nach packet
  packet:=chr(rcpt)+chr(len)+chr(id)+chr(sender)+chr(mpinf)+DataText;
  //Checksumme berechnen
  check:=0;
  for i:=1 to length(packet) do
    case ComboCheck.ItemIndex of
      1://1. XOR
        check:=check xor ord(packet[i]);
      2://2. cyclic XOR
        begin
          asm
            rol check,1;
          end;
          check:=check xor ord(packet[i]);
        end;
      0://3. CRC8
        DoCRC8(check,ord(packet[i]));
    end;
  EditChecksum.Text:=inttostr(check);
  packet:=packet+chr(check);
  up2date:=false;
  if updatehex or CheckAutoUpdate.Checked then Refresh;
end;

procedure TForm1.Refresh;
//refreshes MemoOut with the data of var packet
var
  i:integer;
  hext:string;
begin
  //HEX-Darstellung
  for i:=1 to length(packet) do begin
    hext:=hext+inttohex(ord(packet[i]),2)+' ';
  end;
  MemoOut.Text:=hext;
  up2date:=true;
end;

procedure TForm1.EditRcptChange(Sender: TObject);
begin
  ReCalc(false);
end;

procedure TForm1.EditIDChange(Sender: TObject);
begin
  ReCalc(false);
end;

procedure TForm1.EditSenderChange(Sender: TObject);
begin
  ReCalc(false);
end;

procedure TForm1.EditMPChange(Sender: TObject);
begin
  ReCalc(false);
end;

procedure TForm1.MemoDataChange(Sender: TObject);
//Text von MemoData rckumschreiben
begin
  DataText:=DeCodeText(MemoData.Text);
  ReCalc(false);
end;

procedure TForm1.MemoDataKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then Key:=#0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ComboCheck.ItemIndex:=0;
  ReCalc(true);
end;

procedure TForm1.CmdHexClick(Sender: TObject);
begin
  ReCalc(true);
end;

procedure TForm1.ComboCheckChange(Sender: TObject);
begin
  ReCalc(false);
end;

procedure TForm1.CmdCopyAscClick(Sender: TObject);
begin
  if not up2date then ReCalc(true);
  Clipboard.AsText:=packet;
end;

procedure TForm1.CmdCopyHexClick(Sender: TObject);
var
  i    : integer;
  hext : string;
begin
  if not up2date then ReCalc(true);
  for i:=1 to length(packet) do
    hext:=hext+inttohex(ord(packet[i]),2)+' ';
  Clipboard.AsText:=hext;
end;

// CRC Berechnungen
{  This procedure calculates the cumulative Dallas Semiconductor
   one-wire CRC8 of all bytes passed to it.  The result accumulates
   in the global variable CRC8.}
procedure TForm1.DoCRC8(var crc8:byte;x:byte);
const
   Table : Array[0..255] of Byte = (
        0, 94,188,226, 97, 63,221,131,194,156,126, 32,163,253, 31, 65,
      157,195, 33,127,252,162, 64, 30, 95,  1,227,189, 62, 96,130,220,
       35,125,159,193, 66, 28,254,160,225,191, 93,  3,128,222, 60, 98,
      190,224,  2, 92,223,129, 99, 61,124, 34,192,158, 29, 67,161,255,
       70, 24,250,164, 39,121,155,197,132,218, 56,102,229,187, 89,  7,
      219,133,103, 57,186,228,  6, 88, 25, 71,165,251,120, 38,196,154,
      101, 59,217,135,  4, 90,184,230,167,249, 27, 69,198,152,122, 36,
      248,166, 68, 26,153,199, 37,123, 58,100,134,216, 91,  5,231,185,
      140,210, 48,110,237,179, 81, 15, 78, 16,242,172, 47,113,147,205,
       17, 79,173,243,112, 46,204,146,211,141,111, 49,178,236, 14, 80,
      175,241, 19, 77,206,144,114, 44,109, 51,209,143, 12, 82,176,238,
       50,108,142,208, 83, 13,239,177,240,174, 76, 18,145,207, 45,115,
      202,148,118, 40,171,245, 23, 73,  8, 86,180,234,105, 55,213,139,
       87,  9,235,181, 54,104,138,212,149,203, 41,119,244,170, 72, 22,
      233,183, 85, 11,136,214, 52,106, 43,117,151,201, 74, 20,246,168,
      116, 42,200,150, 21, 75,169,247,182,232, 10, 84,215,137,107, 53);
begin
  crc8 := Table[crc8 xor X];
end;

procedure TForm1.EditIDDblClick(Sender: TObject);
//zeigt eine 2. Form zur Wahl der ID an
var
  i : integer;
begin
  FormIDs.ShowModal;
  if FormIDs.ListIDs.ItemIndex<0 then exit;
  val(copy(FormIDs.ListIDs.Items[FormIDs.ListIDs.ItemIndex],1,3),i,i);
  EditID.Text:=inttostr(i);
end;

procedure TForm1.MemoDataDblClick(Sender: TObject);
//zeigt ein greres MemoFeld in einer 2. Form an
begin
  FormData.MemoData.Text:=MemoData.Text;
  FormData.ShowModal;
  MemoData.Text:=FormData.MemoData.Text;
end;

procedure TForm1.CheckAutoUpdateClick(Sender: TObject);
begin
  if CheckAutoUpdate.Checked then ReCalc(true);
end;

procedure TForm1.CmdSendClick(Sender: TObject);
begin
  ILSend('SEND'+packet);
end;

procedure TForm1.CmdCheckClick(Sender: TObject);
begin
  CheckPacket(packet);
end;

procedure TForm1.CheckPacket(data:string);
//checks a packet for consistence
begin
  //first do all the stuff which can't be wrong
  EditRcpt.Text:=inttostr(ord(data[1]));
  EditSender.Text:=inttostr(ord(data[4]));
  MemoData.Text:=EnCodeText(copy(data,6,length(data)-6));
  //now check the rest
  if length(data)<>ord(data[2]) then
    ShowMessage('Lnge falsch');
  //not checked yet
  EditID.Text:=inttostr(ord(data[3]));
  EditMP.Text:=inttostr(ord(data[5]));
  //recalc
  ReCalc(false);
  if ord(data[length(data)])<>strtoint(EditChecksum.Text) then
    ShowMessage('Checksum falsch');
end;

procedure TForm1.MemoOutKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
//links/rechts=37/39; oben/unten=38/40
var
  i:integer;
begin
  if not up2date then ReCalc(true);
  i:=MemoOut.SelStart div 3;
  StatusBar.Panels[0].Text:='Offset : 0'+inttohex(i,3)+'h = '+inttostr(i);
  StatusBar.Panels[1].Text:='Wert : 0'+inttohex(ord(packet[i+1]),2)+'h = '+inttostr(ord(packet[i+1]));
end;

procedure TForm1.MemoOutClick(Sender: TObject);
//same as above
var
  i:integer;
begin
  if not up2date then ReCalc(true);
  i:=MemoOut.SelStart div 3;
  StatusBar.Panels[0].Text:='Offset : 0'+inttohex(i,3)+'h = '+inttostr(i);
  StatusBar.Panels[1].Text:='Wert : 0'+inttohex(ord(packet[i+1]),2)+'h = '+inttostr(ord(packet[i+1]));
end;

procedure TForm1.MemoOutKeyDown(Sender: TObject; var Key: Word;  Shift: TShiftState);
//links/rechts=37/39; oben/unten=38/40
begin
  if (MemoOut.SelStart mod 3 = 1) and (Key=39) then MemoOut.SelStart:=MemoOut.SelStart+1;
  if (MemoOut.SelStart mod 3 = 0) and (Key=37) then MemoOut.SelStart:=MemoOut.SelStart-1;
end;

procedure TForm1.MemoOutKeyPress(Sender: TObject; var Key: Char);
var
  i:integer;
  a:string;
begin
  if not (Key in ['0'..'9','A'..'F','a'..'f']) then exit;
  i:=MemoOut.SelStart div 3;
  a:=inttohex(ord(packet[i+1]),2);
  a[(MemoOut.SelStart mod 3)+1]:=key;
  if i=length(packet) then packet:=packet+#0;
  packet[i+1]:=chr(strtoint('$'+a));
  i:=MemoOut.SelStart;
  Refresh;
  MemoOut.SelStart:=i+1;
  if (MemoOut.SelStart mod 3 = 2) then MemoOut.SelStart:=MemoOut.SelStart+1;
  MemoOut.SelLength:=1;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  MyRegistry : TMyRegistry;
  i          : integer;
begin
  if started then exit;

  //auto connect
  Client.Connect;
  while Client.state=wsConnecting do begin
    Application.ProcessMessages;
    if Application.Terminated then exit;
  end;
  if Client.State=wsConnected then begin
    Form1.Caption:=Form1.Caption+' (Interlink Client)';
  end else begin
    Server.Listen;
    Form1.Caption:=Form1.Caption+' (Interlink Server)';
  end;

  //Einstellungen laden
  MyRegistry:=TMyRegistry.Create;
  MyRegistry.RootKey:=HKEY_CURRENT_USER;
  MyRegistry.OpenKey('Software\85\CRC_calc\',true);
  with Form1 do
    for i:=0 to ComponentCount-1 do begin
      if (Components[i] is TEdit) then
        (Components[i] as TEdit).text:=MyRegistry.ReadStringD(Components[i].Name,(Components[i] as TEdit).text)
      else if (Components[i] is TRadioButton) then
        (Components[i] as TRadioButton).Checked:=MyRegistry.ReadBoolean(Components[i].Name,(Components[i] as TRadioButton).Checked)
      else if (Components[i] is TListBox) then
        (Components[i] as TListBox).ItemIndex:=MyRegistry.ReadIntegerD(Components[i].Name,(Components[i] as TListBox).ItemIndex)
      else if (Components[i] is TComboBox) then
        (Components[i] as TComboBox).ItemIndex:=MyRegistry.ReadIntegerD(Components[i].Name,(Components[i] as TComboBox).ItemIndex)
      else if (Components[i] is TCheckBox) then
        (Components[i] as TCheckBox).Checked:=MyRegistry.ReadBoolean(Components[i].Name,(Components[i] as TCheckBox).Checked);
    end;
  started:=true;
end;

procedure TForm1.ILGet(text:string);
//received packet to analyse?
begin
  if copy(text,1,4)<>'ANAL' then exit;
  //yes
  delete(text,1,4);
  CheckPacket(text);
end;

function TForm1.DeCodeText(text:String):string;
var
  i,j : integer;
  a   : string;
begin
  i:=1;
  while i<=length(text) do begin
    case text[i] of
      '#':if text[i+1]='#' then begin
            a:=a+'#';
            inc(i);
          end else begin
            j:=i+1;
            while (j<=length(text)) and (text[j]<>'>') and
                  ((text[j]>='0') and (text[j]<='9')) do inc(j);
            if j>i+1 then
              a:=a+chr(strtoint(copy(text,i+1,min(3,j-i-1))))
            else
              a:=a+'#';
            inc(i,min(3,j-i-1));
          end;
      '<':begin
          inc(i);
          if text[i]='<' then begin
            a:=a+'<';
            dec(i);
          end else begin
            j:=i;
            while (j<=length(text)) and (text[j]<>'>') and
                  ((text[j]>='0') and (text[j]<='9')) do inc(j);
            if j>i then begin
              a:=a+chr(strtoint(copy(text,i,min(3,j-i))));
              inc(i,min(3,j-i));
              if text[i]<>'>' then dec(i);
            end else begin
              a:=a+'<';
              dec(i);
            end;
          end;
        end;
      else
        a:=a+text[i];
    end;
    inc(i);
  end;
  result:=a;
end;

function TForm1.EncodeText(text:string):string;
//replaces chars<#32 and >#127 by their asc values
var
  i : integer;
  b : string;
begin
  for i:=1 to length(text) do
    if (text[i]<#32) or (text[i]>#127) then
      b:=b+'<'+inttostr(ord(text[i]))+'>'
    else
      b:=b+text[i];
  result:=b;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
//Einstellungen speichern
var
  MyRegistry : TMyRegistry;
  i          : integer;
begin
  MyRegistry:=TMyRegistry.Create;
  MyRegistry.RootKey:=HKEY_CURRENT_USER;
  MyRegistry.OpenKey('Software\85\CRC_calc\',true);
  with Form1 do
    for i:=0 to ComponentCount-1 do begin
      if (Components[i] is TEdit) then
        MyRegistry.WriteString(Components[i].Name,(Components[i] as TEdit).text)
      else if (Components[i] is TRadioButton) then
        MyRegistry.WriteBoolean(Components[i].Name,(Components[i] as TRadioButton).Checked)
      else if (Components[i] is TListBox) then
        MyRegistry.WriteInteger(Components[i].Name,(Components[i] as TListBox).ItemIndex)
      else if (Components[i] is TComboBox) then
        MyRegistry.WriteInteger(Components[i].Name,(Components[i] as TComboBox).ItemIndex)
      else if (Components[i] is TCheckBox) then
        MyRegistry.WriteBoolean(Components[i].Name,(Components[i] as TCheckBox).Checked);
      end;
  MyRegistry.Free;
end;

//////////////////////////// \/ MULTI SERVER \/ ////////////////////////////////
//global vars:
//ilbuffer:string;use:array of TWSocket;started:boolean;//in FormShow
procedure TForm1.ServerDataAvailable(Sender: TObject; Error: Word);
//repeat to all
var
  i,len:integer;
begin
  ilbuffer:=ilbuffer+(Sender as TWSocket).Text;
  if length(ilbuffer)<3 then exit;
  if ilbuffer[1]<>'L' then begin
    ilbuffer:='';
    exit;
  end;
  len:=ord(ilbuffer[2])+256*ord(ilbuffer[3]);
  if length(ilbuffer)<len then exit;
  for i:=0 to high(use) do
    if use[i].state<>wsConnected then begin
      use[i]:=use[high(use)];
      SetLength(use,length(use)-1);
    end else(use[i] as TWSocket).Text:=ilbuffer;
  ILGet(copy(ilbuffer,4,len-3));//pass content
  Delete(ilbuffer,1,len);//delete from buffer
end;

procedure TForm1.ILSend(data:string);
var
  i,len:integer;
  text2send:string;
begin
  len:=length(data)+3;//3 for 'L' + 2 bytes at the beginning which contain length info
  text2send:='L'+chr(len mod 256)+chr(len div 256)+data;
  for i:=0 to high(use) do
    if use[i].state<>wsConnected then begin
      use[i]:=use[high(use)];
      SetLength(use,length(use)-1);
    end else(use[i] as TWSocket).Text:=text2send;
end;

procedure TForm1.ServerClientConnect(Sender: TObject;  Client: TWSocketClient; Error: Word);
begin
  Client.OnDataAvailable:=Server.OnDataAvailable;
  ImageConnect.Visible:=true;
  SetLength(use,length(use)+1);
  use[high(use)]:=(Client as TWSocket);
end;

procedure TForm1.ClientSessionConnected(Sender: TObject; Error: Word);
begin
  SetLength(use,length(use)+1);
  ImageConnect.Visible:=true;
  use[high(use)]:=(Client as TWSocket);
end;

procedure TForm1.ClientDataAvailable(Sender: TObject; Error: Word);
var
  len:integer;
begin
  ilbuffer:=ilbuffer+(Sender as TWSocket).Text;
  if length(ilbuffer)<3 then exit;
  if ilbuffer[1]<>'L' then begin
    ilbuffer:='';
    exit;
  end;
  len:=ord(ilbuffer[2])+256*ord(ilbuffer[3]);
  if length(ilbuffer)<len then exit;
  ILGet(copy(ilbuffer,4,len-3));//pass content
  Delete(ilbuffer,1,len);//delete from buffer
end;

procedure TForm1.ServerClientDisconnect(Sender: TObject;  Client: TWSocketClient; Error: Word);
var
  i,j:Integer;
begin
  for i:=0 to high(use) do
    if use[i]=(Client as TWSocket) then break;
  for j:=i to high(use)-1 do
    use[j]:=use[j+1];
  SetLength(use,length(use)-1);
  if length(use)=0 then ImageConnect.visible:=false;
end;

procedure TForm1.ClientSessionClosed(Sender: TObject; Error: Word);
begin
  if not started then exit;
  ShowMessage('Server close');
  Application.Terminate;
end;
//////////////////////////// /\ MULTI SERVER /\ ////////////////////////////////

end.
